/*
	Program cuts off zero level sound file at the end of a file. 
	This is necesarry for combining mp3 decoded pieces of larger audio file
	
*/

#include <unistd.h>
#include <stdio.h>
#include <sndfile.h>

#define MAX_CUT 66

struct frame {
	short left ;
	short right ;
} ;


int main ( int argc, const char ** argv ) {

	char * filename ;
	SNDFILE *audiofile ;
	SF_INFO sfinfo ;
	struct frame Frame ;
	size_t inframes ;
	int i ;


	if ( argc < 2 ) {
		printf ( "Usage: %s filename" , argv[0] ) ;
		return 1;
	}
	
	filename = (char *)argv[1];

	audiofile = sf_open_read ( filename, &sfinfo ) ;
	printf ( "Sample Rate %d\n" , sfinfo.samplerate );
	printf ( "Samples %d\n" , sfinfo.samples );
	printf ( "Channels %d\n" , sfinfo.channels );
	printf ( "PCMbitwidth %d\n" , sfinfo.pcmbitwidth );
	printf ( "Format 0x%0x\n" , sfinfo.format);
	printf ( "Sections %d\n" , sfinfo.sections );
	printf ( "Seekable %d\n" , sfinfo.seekable );

	i = 1 ;
	inframes = sf_readf_short ( audiofile, (short *)&Frame , 1 ) ;
	while ( inframes >0 ) {
		printf ( "%06d %06d %06d\n" , i++ , Frame.left , Frame.right ) ;
		inframes = sf_readf_short ( audiofile, (short *) &Frame , 1 ) ;
	}

	sf_close ( audiofile ) ;

	return 0 ;
}
