/*
	Program cats wav files into output wav file.
	wav setup is taken from first cated wav file.
*/
#include <unistd.h>
#include <stdio.h>
#include <sndfile.h>

#define MAX_FRAMES 1638400

struct frame {
	short left ;
	short right ;
} ;

int main ( int argc, const char ** argv ) {

	char * filename ;
	char * outfile ;
	char workfile[255] ;
	SNDFILE *audiofile ;
	SNDFILE *leftaudiofile ;
	SNDFILE *rightaudiofile ;
	SF_INFO sfinfo ;
	SF_INFO leftinfo ;
	SF_INFO rightinfo ;
	struct frame Frames[MAX_FRAMES] ;
/*	struct frame Frame ;
*/
	size_t inframes, outframes ;
	int i,j ;

	leftaudiofile = NULL ;
	rightaudiofile = NULL ;
	
	if (( argc < 4 ) || (strcmp ( argv[1] ,"-o"))) {
		printf ( "Usage: %s -o outfile filename(s)\n" , argv[0] ) ;
		return 1;		
	} 
	
	if ( argv[2] ) {
		outfile = (char *)argv[2] ;
	} else {
		printf ( "Usage: %s -o outfile filename(s)\n" , argv[0] ) ;
		return 1;
	}

	filename = (char *)argv[3];
	audiofile = sf_open_read ( filename, &sfinfo ) ;
	memcpy ( &leftinfo, &sfinfo , sizeof ( sfinfo ));
	memcpy ( &rightinfo, &sfinfo , sizeof ( sfinfo ));
	leftinfo.channels = 1 ;
	rightinfo.channels = 1 ;
	
	sprintf ( workfile , "%s.left" , outfile ) ;
	leftaudiofile = sf_open_write ( workfile , &leftinfo ) ;
	sprintf ( workfile , "%s.right" , outfile ) ;
	rightaudiofile = sf_open_write ( workfile , &rightinfo ) ;
	i = 0;
	while ( i < sfinfo.samples ) {
		inframes = sf_readf_short ( audiofile,(short *) &Frames , MAX_FRAMES ) ;
		for ( j=0 ; j<inframes; j++ ) {
			outframes = sf_writef_short ( leftaudiofile, (short *)&Frames[j].left , 1 );
			outframes = sf_writef_short ( rightaudiofile, (short *)&Frames[j].right , 1 );
		}
		i += inframes ;
	}
	sf_close ( audiofile ) ;
	sf_close ( leftaudiofile ) ;
	sf_close ( rightaudiofile ) ;
	return 0 ;
}
