/*
	Program cats wav files into output wav file.
	wav setup is taken from first cated wav file.
*/
#include <unistd.h>
#include <stdio.h>
#include <sndfile.h>

#define MAX_FRAMES 8192

int main ( int argc, const char ** argv ) {

	char * filename ;
	SNDFILE *audiofile ;
	SF_INFO sfinfo ;
	int time,min,sec ;

	if ( argc < 2 ) {
		printf ( "Usage: %s filename(s)\n" , argv[0] ) ;
		return 1;		
	} 
	
	filename = (char *)argv[1];
	audiofile = sf_open_read ( filename, &sfinfo ) ;
	time = sfinfo.samples / sfinfo.samplerate ;
	min=time/60;
	sec=time%60;
	fprintf ( stdout, "%02d:%02d\n" , min , sec) ;
	
	sf_close ( audiofile ) ;
	return 0 ;
}
